/*
 * Copyright 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***
    clang.h - general purpose types and constants for the C language
    If assert() is used (see assert.h) be sure to include <stdio.h> first.
    $Header: /bvd/att/usr/src/cmd/demo/src/closeup/RCS/clang.h,v 1.2 89/02/08 18:49:38 olson Exp $
***/

/* assert macro for program verification */
#include "assert.h"

/* don't redefine what's in System V <sys/types.h> */
/* (4.3bsd is similar but uses _TYPES_), (but why not just include sys/types.h? */
#if !defined(__TYPES__) && !defined(_TYPES_) && !defined(TYPES_H) && !defined(_TYPES_H_)
    typedef  unsigned char   u_char;
    typedef  unsigned short  u_short;
    typedef  unsigned int    u_int;
    typedef  unsigned long   u_long;
#endif

typedef  int		 BOOL;
typedef  char		 *STRINGP;
typedef  char		 *ADDRESS;
typedef  void		 (*FUNC)();

typedef  char		 *StringPtr;
typedef  int		 Bool;
typedef  char		 *Address;
typedef  void		 (*FuncPtr)();

#ifndef FALSE
#   define  FALSE  0
#   define  TRUE   (!FALSE)
#endif

#ifndef  NULL
#   define  NULL  0
#endif

#define  AND  &&
#define  OR   ||
#define  NOT  !
#define  BITXOR  ^
#define  MOD  %

#define  ISNULLSTRING(s)  (((s) == NULL) OR (*(s) == '\0'))
#define  MIN(a,b)   (((a) <= (b)) ? (a) : (b))
#define  MAX(a,b)   (((a) >= (b)) ? (a) : (b))
#define  ABS(v)	    (((v) >= 0) ? (v) : -(v))
#define  SIGN(v)    (((v) >= 0) ? 1 : -1)

/*** assume 'data' is a long or u_long ***/
#define HIGH16(data) (0xffff & (data >> 16))
#define LOW16(data) (0xffff & data)
